.\"
.\"Copyright (c) 2022 Sean Davies <skd@skd.id.au>
.\"
.\"Permission to use, copy, modify, and distribute this software for any
.\"purpose with or without fee is hereby granted, provided that the above
.\"copyright notice and this permission notice appear in all copies.
.\"
.\"THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
.\"WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
.\"MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
.\"ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
.\"WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
.\"ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
.\"OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
.\"
.Dd $Mdocdate: September 23 2022 $
.Dt NGINX-GEOBLOCK 8
.Os
.Sh NAME
.Nm nginx-geoblock
.Nd restrict nginx connections by geographical location
.Sh SYNOPSIS
.Nm
.Op Fl a
.Op Fl r | x
.Ar cctld
.Sh DESCRIPTION
.Nm
is a utility that allows you restrict
.Xr nginx 8
connections by geographical location by downloading and processing the country
IP blocks for the country code top-level domain given as
.Ar cctld .
.Pp
The IP addresses are prepped using the default filter action to
.Em deny
the connections, the file must then be soured using an include statement within
the
.Xr nginx 8
configuration file.
.Pp
The output file is saved to the following location where
.Em xx
is the two letter
.Ar cctld
identifier.
.Pp
.Pa /etc/nginx/conf.d/xx-aggregated.zone
.Pp
Alternatively, the processed data can printed to stdout.
.Pp
The options are as follows:
.Bl -tag -width Ds
.It Fl a
Change the filter action from
.Em deny
to
.Em allow .
.It Fl r
Test and reload the
.Xr nginx 8
service.
.It Fl x
Print processed data to stdout and exit.
.El
.Sh EXIT STATUS
.Ex -std
.Sh EXAMPLES
The following creates a deny list of all New Zealand IP addresses.
.Bd -literal -offset indent
# nginx-geoblock nz
.Ed
.Pp
The file must then be sourced within the
.Xr nginx 8
configuration.
.Bd -literal -offset indent
server {
    include /etc/nginx/conf.d/nz-aggregated.zone;
    ...
}
.Ed
.Pp
The following creates an allow list of only Australian IP addresses.
.Bd -literal -offset indent
# nginx-geoblock -a au
.Ed
.Pp
And sourced within
.Xr nginx 8
with an additional deny statement.
.Bd -literal -offset indent
server {
    include /etc/nginx/conf.d/au-aggregated.zone;
    deny all;
    ...
}
.Ed
.Sh SEE ALSO
.Xr curl 1 ,
.Xr nginx 8
.Pp
.Lk https://www.ipdeny.com
.Sh AUTHORS
.An Sean Davies Aq Mt skd@skd.id.au
.Sh CAVEATS
Depends on
.Xr curl 1 .
